package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseAutoLevel;
import com.ruoyi.web.base.service.IBaseAutoLevelService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 自动转级别 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-04
 */
@RestController
@RequestMapping("/base-auto-level")
public class BaseAutoLevelController {
    @Autowired
    private IBaseAutoLevelService baseAutoLevelService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("自动转级别管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseAutoLevel baseAutoLevel, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseAutoLevelService.count(new QueryWrapper<BaseAutoLevel>().eq("org_id",loginOrgId).eq("level_no", baseAutoLevel.getLevelNo())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseAutoLevel.setOrgId(loginOrgId);
        baseAutoLevel.setCreateBy(getUsername());

        return success(baseAutoLevelService.save(baseAutoLevel));
    }

    @ApiOperation("自动转级别管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseAutoLevel baseAutoLevel, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseAutoLevelService.count(new QueryWrapper<BaseAutoLevel>().ne("id",baseAutoLevel.getId()).eq("org_id",loginOrgId).eq("level_no", baseAutoLevel.getLevelNo())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseAutoLevel.setUpdateBy(getUsername());
        return success(baseAutoLevelService.updateById(baseAutoLevel));
    }

    @ApiOperation("自动转级别管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseAutoLevelService.removeById(s);
        }
        return success();
    }

    @ApiOperation("自动转级别管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(baseAutoLevelService.list(new QueryWrapper<BaseAutoLevel>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("自动转级别管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseAutoLevelService.page(new Page<BaseAutoLevel>(pageNum,pageSize),new QueryWrapper<BaseAutoLevel>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("自动转级别管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseAutoLevelService.getById(id));
    }

}
